/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is ForumZilla 0.1.1.
 *
 * The Initial Developer of the Original Code is Zapogee, Inc.
 * Portions created by Zapogee, Inc. are Copyright (C) 2001
 * Zapogee, Inc.  All Rights Reserved.
 *
 * Contributor(s):
 *   Myk Melez, <myk@melez.com>, original author
 */

function enumerateInterfaces(obj)
{
  var interfaces = new Array();
  for (i in Components.interfaces)
  {
    try
    {
      obj.QueryInterface(Components.interfaces[i]);
      interfaces.push(i);
    }
    catch(e) {}
  }
  return interfaces;
}

function enumerateProperties(obj, excludeComplexTypes)
{
  var properties = "";
  for (p in obj)
  {
    try
    {
      if (excludeComplexTypes
          && (typeof obj[p] == 'object' || typeof obj[p] == 'function')) next;
      properties += p + " = " + obj[p] + "\n";
    }
    catch(e) {
      properties += p + " = " + e + "\n";
    }
  }
  return properties;
}

// minimal implementation of nsIOutputStream for use by dumpRDF, adapted from
// http://groups.google.com/groups?selm=20011203111618.C1302%40erde.jan.netgaroo.de
var DumpOutputStream = {
  write: function(buf, count) { dump(buf); return count; }
};

function dumpRDF( aDS ) {
  var serializer = Components.classes["@mozilla.org/rdf/xml-serializer;1"]
    .createInstance( Components.interfaces.nsIRDFXMLSerializer );
  
  serializer.init( aDS );
  
  serializer.QueryInterface( Components.interfaces.nsIRDFXMLSource )
    .Serialize( DumpOutputStream );
}
